// Backtester.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#define CPP

#include <iostream>
#include <string>
#include "../CR Expert/App.h"
#include "../CPP/CalculusRobot/ValuesProvider/ValuesProvider.h"

using namespace std;

void CustomConfiguration()
{
    CConfig::UseSellBuyNeuralNetworks = true;
}

void Display()
{
    cout << "Backtester.exe FarPastData.txt USD" << endl;
    cin.get();
}

int main(int argc, char* argv[])
{
    if (argc != 3)
    {
        Display();
        return -1;
    }
    else
    {
        CValuesProvider provider;
        CMarket market;

        CustomConfiguration();
        GetInteroperability().Assign(market, provider);

        provider.SetAccountCurrency(string(argv[2]));
        provider.Init(string(argv[1]));
        provider.AddToCurrentRow(CConfig::PastHoursCount);

        if (GetRunner().Init())
        {
            do
            {
                GetRunner().OnInterval();
                market.CheckOrders();
            } while (provider.AssignNextRow());
            GetRunner().DeInit();
            cout << endl << "Press any key to close." << endl;
            cin.get();
            return 0;
        }
        else
        {
            return -1;
        }
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
