#pragma once

#ifndef FILE_NODE
#define FILE_NODE

#include <string>
#include <vector>
#include <memory>

using namespace std;

class CNode
{
	int MAX_DEPTH = 3;

public:
	vector<shared_ptr<CNode>> LeftPairs;
	vector<shared_ptr<CNode>> RightPairs;
	string Pair;
};

class CTree
{
	int MAX_DEPTH = 4;
	string m_Currency;

	void FillTree(vector<string>& pairs, shared_ptr<CNode> node, int depth);
	static bool CurrencyOnLeft(string pair, string currency);
	static bool CurrencyOnRight(string pair, string currency);
	static bool CommonOnLeft(string pair, string secondPair);
	static bool CommonOnRight(string pair, string secondPair);
	bool GetClosestPaths(shared_ptr<CNode> node, vector<vector<string>>& paths, vector<string> path);

public:
	shared_ptr<CNode> Root;

	void Init(string pair, vector<string>& currencyPairs, string currency);
	static string LeftCurrency(string pair);
	static string RightCurrency(string pair);
	vector<string> GetClosestPath();
};
#endif