/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

#ifndef FILE_INTERNAL_CPP_GENERIC_ARRAY
#define FILE_INTERNAL_CPP_GENERIC_ARRAY

#include <vector>
#include <algorithm>

using namespace std;

//+------------------------------------------------------------------+
template <typename T>
class IGenericArray{
	 private:
		 vector<T> m_Vals;

	 public:
		 void Resize(int am)
		 {
			 m_Vals.resize(am);
		 }         
		 
		 void SetValue(int nr, const T val)
		 {
			 m_Vals[nr] = val;
		 }
		 
		 const T GetValue(int nr) 
		 {
			 return m_Vals[nr];
		 }
		 
		 const int Size()
		 {
			 return (int)m_Vals.size();
		 }

		 void Sort()
		 {
			 sort(m_Vals.begin(), m_Vals.end());
		 }

		 void Add(const T val)
		 {
			 m_Vals.insert(m_Vals.end(), val);
		 }

		 void Remove(int nr)
		 {
			 m_Vals.erase(m_Vals.begin() + nr);
		 }
};
//+------------------------------------------------------------------+
#endif