/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

#ifndef FILE_INTERNAL_CPP_SORTABLE_ARRAY
#define FILE_INTERNAL_CPP_SORTABLE_ARRAY

#include <vector>
#include <algorithm>

using namespace std;

//+------------------------------------------------------------------+
template <typename T>
class ISortableArray{
	 private:
		 vector<vector<T>> m_Vals;

	 public:
		 void Resize(int am)
		 {
			 size_t size = m_Vals.size();

			 m_Vals.resize(am);
			 for (size_t i = size; i < m_Vals.size(); i++)
			 {
				 m_Vals[i].resize(2);
			 }
		 }         
		 
		 void SetValue(int nr, const T val)
		 {
			 m_Vals[nr][0] = val;
		 }

		 T GetValue(int nr)
		 {
			 return m_Vals[nr][0];
		 }
		 
		 void SetPos(int nr, int pos)
		 {
			 m_Vals[nr][1] = pos;
		 }

		 int GetPos(int nr)
		 {
			 return (int)m_Vals[nr][1];
		 }

		 const int Size()
		 {
			 return (int)m_Vals.size();
		 }

		 void Sort()
		 {
			 //sort(m_Vals.begin(), m_Vals.end());
		 }

		 int BinarySearch(const T pos)
		 {
			 int nr = -1;

			 for (int i = 0; i < m_Vals.size(); i++)
			 {
				 if (m_Vals[i][0] == pos)
				 {
					 nr = i;
					 break;
				 }
			 }

			 return nr;
		 }

		 void RemoveNr(int nr)
		 {
			 m_Vals.erase(m_Vals.begin() + nr);
		 }
};
//+------------------------------------------------------------------+
#endif