/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

#ifndef FILE_INTERNAL_CPP_STRING
#define FILE_INTERNAL_CPP_STRING

#include "InternalCppGenericObjectArray.h"
#include <string>

using namespace std;

//+------------------------------------------------------------------+
class IString {
private:
	string m_String;

public:
	bool static AreEqual(IString a, IString b);

	IString();

	IString(int number);
	
	IString(const char* str);

	IString(const IString &other);

	void AssignString(const char* str);

	void AssignString(IString str);

	void StringSplit(char c, IGenericObjectArray<IString> &res);

	IString StringTrimLeft();

	IString StringTrimRight();
	
	IString SubString(int beg, int am);
	
	int StringLen();

	bool Contains(IString &search);

	const char* GetPlatformString() const;

	IString operator+(IString other);
	
	IString& operator+(const char* other);
	
	void operator+=(IString other);
	
	void operator+=(const char* other);
	
	void StringReplace(const char* org, const char* rep);

	char CharAtPos(int pos);
};
//+------------------------------------------------------------------+
#endif
