#ifndef FILE_MARKET
#define FILL_MARKET

#include <string>
#include <vector>

#include "../Internal/InternalCppString.h"
#include "../Internal/InternalCppFileWriter.h"
#include "../ValuesProvider/ValuesProvider.h"

using namespace std;

class COrder {
public:
	bool buy;
	double lotSize;
	double price;
	double stopLoss;
	double takeProfit;
	string symbol;
	time_t openTime;
	double cost;

	unsigned long nr;

	static bool compare(COrder &i1, COrder &i2);
	double Profit(CValuesProvider *vp);
	double Cost(CValuesProvider *vp);
};

class CMarket {
private:
	static unsigned long Nr;
	vector<COrder> m_Orders;
	IFileWriter m_Writer;
	double m_Balance;
	bool Find(unsigned long ticket, vector<COrder>::iterator  &order);
	CValuesProvider* m_ValuesProvider;
	double m_Invested;

public:
	CMarket();

	double OrderProfit(unsigned long ticket);

	double OrderOpenPrice(unsigned long ticket);
	
	double OrderCurrentPrice(unsigned long ticket);
	
	double OrderTakeProfit(unsigned long ticket);
	
	double OrderStopLoss(unsigned long ticket);
	
	bool CloseOrder(unsigned long ticket);

	time_t OrderOpenTime(unsigned long ticket);
	
	int OrderSend(IString symbol, bool buy, double lotSize, double price, double stopLoss, double takeProfit);

	void CheckOrders();

	void AddValuesProvider(CValuesProvider& provider);

	double AccountBalance();

	void CloseAll();	
		
	int AmountOrders();

	unsigned long OrderNr(int nr);
};
#endif