#pragma once

#ifndef FILE_VALUES_PROVIDER
#define FILL_VALUES_PROVIDER

#include <time.h>
#include <string>
#include <vector>
#include <map>

using namespace std;

class CRow {
private:
	time_t m_RowDate;
	vector<double> m_ColumnsValues;

public:
	void Init(int am);

	time_t GetDate();

	void SetDate(time_t time);

	double GetColumnValue(int nr);

	void SetColumnValue(int nr, double val);
};

class CPairInfo
{
public:
	int Nr;
	vector<string> PathStr;
};

class CValuesProvider {
private:
	time_t m_Time;
	vector<string> m_ColumnsNames;
	vector<CRow> m_Rows;
	long m_RowNr;
	map<string, CPairInfo> m_Map;
	string m_Currency;

	void ParseLine(string line);
	void PreparePaths(string currency);
	double Multiplicator(string currency, string pair, string& ocurrency);

public:
	void Init(string filename);

	double ValueOfColumnAtCurrentTime(string column);

	double ValueOfColumnInSpecificTime(string column, time_t time);

	string ColumnName(int nr);

	int ColumnsTotal();

	bool AssignNextRow();

	void AddToCurrentRow(double hours);

	time_t CurrentTime();

	void SetAccountCurrency(string currency);

	string GetAccountCurrency();

	double Multiplicator(string pair);
};
#endif