/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

#ifndef FILE_CURRENCY_PAIR
#define FILE_CURRENCY_PAIR

#include "../../Interoperability/String.h"
#include "../../Interoperability/DateTime.h"
#include "../LibrariesInteroperability.h"

//+------------------------------------------------------------------+
//Holds information about Trade Symbol
class CCurrencyPair{
    public:
        IString Symbol;//Trade Symbol Name
        bool Buy;//What type of trades are to be performed on this Symbol (Buy/Sell)
        double Profit;//What Profit was established on trading this Symbol in last time frame of analysis
        double ProportionalProfit;//Profit proportional to Current Price of Symbol
        
        void CalculateProportionalProfit(IDateTime &date)//Calculates Proportional Profit of Profit in relation to Current Price of Symbol
        {
            double val = GetInteroperability().GetPriceAtTime(Symbol, date);
            
            if(val != 0.0)
            {
                ProportionalProfit = Profit / val;
            }
        }
};    
//+------------------------------------------------------------------+
#endif