/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

#ifndef FILE_GENERIC_ARRAY
#define FILE_GENERIC_ARRAY

#ifndef MQL4
#ifndef MQL5
#define CPP
#endif
#endif

#ifndef CPP
//+------------------------------------------------------------------+
template <typename T>
class IGenericArray{
	 private:
		 T m_Array[];
		 int m_Size;
		 int GROW_BY;

	 public:
		 IGenericArray()
		 {
			 GROW_BY = 5;
			 m_Size = 0;
		 }

		 void Resize(int am)
		 {
			 int curSize = ArraySize(m_Array);
			 
			 ArrayResize(m_Array, am);
			 m_Size = am;
			 if(typename(T) == "int")
			 {
				 for(int i=curSize;i<am;i++)
				 {
					 m_Array[i] = 0;
				 }
			 }
			 else if(typename(T) == "double")
			 {
				 for(int i=curSize;i<am;i++)
				 {
					 m_Array[i] = 0.0;
				 }
			 }
			 else if(typename(T) == "bool")
			 {
				 for(int i=curSize;i<am;i++)
				 {
					 m_Array[i] = false;
				 }
			 }
		 }

		 void Add(const T val)
		 {
			 if (m_Size < ArraySize(m_Array))
			 {

			 }
			 else
			 {
				 ArrayResize(m_Array, m_Size + GROW_BY);
			 }
			 m_Array[m_Size] = val;
			 m_Size++;
		 }

		 void Remove(int nr)
		 {
			 if (nr == m_Size - 1)
			 {
				 m_Size--;
			 }
			 else if (nr < m_Size - 1)
			 {
				 m_Array[nr] = m_Array[m_Size - 1];
				 m_Size--;
			 }
		 }
		 
		 void SetValue(int nr, const T val)
		 {
			 m_Array[nr] = val;
		 }
		 
		 const T GetValue(int nr)
		 {
			 return m_Array[nr];
		 }
		 
		 const int Size()
		 {
			 return m_Size;
		 }

		 void Sort()
		 {
			 ArraySort(m_Array);
		 }
};
//+------------------------------------------------------------------+
#else

#include "../CPP/CalculusRobot/Internal/InternalCppGenericArray.h"

#endif
#endif