﻿/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;

namespace CoinThrower
{
    class TimeLine
    {
        private List<PointInTime> m_Points;

        public void ThrowCoins(int amount)
        {
            m_Points = new List<PointInTime>();
            for (int i = 0; i < amount; i++)
            {
                PointInTime pit = new PointInTime();
                double time = Rand.NextDouble();

                pit.ThrowCoin(time);
                m_Points.Add(pit);
            }
        }

        public void DisplayAmounts()
        {
            int pos = 0;
            int neg = 0;

            for (int i = 0; i < m_Points.Count; i++)
            {
                if (m_Points[i].Head)
                {
                    pos++;
                }
                else
                {
                    neg++;
                }
            }
            Console.WriteLine("All Heads : {0}, All Tails : {1}.", pos, neg);
        }

        public void DisplayAmounts(double barrier)
        {
            int am = 0;
            int i = 0;

            while (m_Points[i].Time < barrier)
            {
                if (m_Points[i].Head)
                {
                    am++;
                }
                else
                {
                    am--;
                }
                i++;
                if (i == m_Points.Count)
                {
                    break;
                }
            }
            Console.WriteLine("Before Barrier : {0}.", am);
            while (i < m_Points.Count)
            {
                if (m_Points[i].Head)
                {
                    am++;
                }
                else
                {
                    am--;
                }
                i++;
            }
            Console.WriteLine("After Barrier : {0}.", am);
        }

        public List<PointOnChart> GetChart(int amount)
        {
            List<PointOnChart> chart = new List<PointOnChart>();
            double timeDiff = 1.0 / amount;
            double place = 0.0;
            int am = 0;

            m_Points.Sort();
            for (int i = 0; i < m_Points.Count; i++)
            {
                PointOnChart poc = new PointOnChart();
                poc.Time = place;

                while (m_Points[i].Time < place)
                {
                    if (m_Points[i].Head)
                    {
                        am++;
                    }
                    else
                    {
                        am--;
                    }
                    if (i < m_Points.Count - 1)
                    {
                        i++;
                    }
                    else
                    {
                        break;
                    }
                }
                poc.Value = am;
                place += timeDiff;
                chart.Add(poc);
            }
            return chart;
        }
    }
}
