﻿/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;
using System.Globalization;

namespace CommonLibrary
{
    public class FileLooks
    {
        public List<Look> Looks { get; }

        public FileLooks()
        {
            Looks = new List<Look>();
        }

        public List<Look> GetSubSetOfLooks(int first, int last)
        {
            List<Look> list = new List<Look>();

            for (int i = first; i <= last; i++)
            {
                list.Add(Looks[i]);
            }
            return list;
        }

        public void FillLooks(FileLines lines)
        {
            Look look;

            Looks.Clear();
            for (int i = 0; i < lines.LinesAmount(); i++)
            {
                Line line = lines.GetLineNr(i);

                look = ParseLine(line.Content);
                if (look != null)
                {
                    look.Date = line.Date;
                    Looks.Add(ParseLine(line.Content));
                }
            }
        }

        private Look ParseLine(string line)
        {
            Look look = new Look();
            string[] arr = line.Split(new char[] { ',' });
            string[] tmp;
            string val;

            look.Date = DateTime.Parse(arr[0]);

            tmp = arr[1].Split(new char[] { ':' });
            val = tmp[1].Trim();
            look.Profit = double.Parse(val, CultureInfo.InvariantCulture);

            tmp = arr[2].Split(new char[] { ':' });
            val = tmp[1].Trim();
            look.Balance = double.Parse(val, CultureInfo.InvariantCulture);

            tmp = arr[3].Split(new char[] { ':' });
            val = tmp[1].Trim();
            look.Lot = double.Parse(val, CultureInfo.InvariantCulture);

            tmp = arr[4].Split(new char[] { ';' });
            for (int i = 1; i < tmp.Length; i++)
            {
                string str = tmp[i];
                LookProfit lp = new LookProfit();
                string[] tmp2;

                tmp2 = str.Split(new char[] { ':' });
                lp.ProfitId = int.Parse(tmp2[0]);
                lp.Profit = double.Parse(tmp2[1], CultureInfo.InvariantCulture);

                look.Profits.Add(lp);
            }
            return look;
        }
    }
}
