﻿/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;

namespace CommonLibrary
{
    public class Look
    {
        public DateTime Date { get; set; }
        public double Balance { get; set; }
        public double Lot { get; set; }
        public double Profit { get; set; }
        public List<LookProfit> Profits { get; }

        public Look()
        {
            Profits = new List<LookProfit>();
        }

        public void RevereProfits()
        {
            foreach (LookProfit lp in Profits)
            {
                lp.ReverseProfit();
            }
            Profit = -Profit;
        }

        public void NormalizeProfits()
        {
            double div = Lot / 0.01;

            foreach(LookProfit lp in Profits)
            {
                lp.Profit /= div;
            }
            Profit /= div;
        }

        public bool ConsisitentProfit()
        {
            double prof = 0.0;

            foreach (LookProfit lp in Profits)
            {
                prof += lp.Profit;
            }
            double P = Profit;
            double p = prof;

            if(P < 0.0)
            {
                P = -P;
            }

            if( p < 0.0)
            {
                p = -p;
            }

            {
                return (P >= 0.95 * p && P <= 1.05 * p) || (0.95 * P <= p && 1.05 * P >= p) || (P == 0.0 && p<=0.000001);
            }
            
        }
    }
}
