﻿/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;

namespace MethodGCalculator
{
    public class DateTimeHelper
    {
        private static double Difference(DateTime before, DateTime after)
        {
            DateTime date = before;
            double seconds = 0;

            do
            {
                if (date.DayOfWeek != DayOfWeek.Saturday && date.DayOfWeek != DayOfWeek.Sunday)
                {
                    seconds += 60 * 60 * 24;
                }
                date = date.AddDays(1);
            } while (date < after);
            seconds -= (date - after).TotalSeconds;
            return seconds;
        }

        public static double DifferenceHours(DateTime before, DateTime after)
        {
            return Difference(before, after) / (60 * 60);
        }

        public static DateTime MinusHours(DateTime date, double hours)
        {
            while (hours > 24)
            {
                if (date.DayOfWeek != DayOfWeek.Saturday && date.DayOfWeek != DayOfWeek.Sunday)
                {
                    hours -= 24.0;
                }
                date = date.AddHours(-24.0);
            }
            date = date.AddHours(-hours);
            if (date.DayOfWeek == DayOfWeek.Sunday)
            {
                date = date.AddHours(-24.0);
            }
            if (date.DayOfWeek == DayOfWeek.Saturday)
            {
                date = date.AddHours(-24.0);
            }
            return date;
        }
    }
}
