﻿/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;

namespace MethodGCalculator
{
    public class Res : IComparable
    {
        public double Profit { get; set; }
        public double ReverseProfit { get; set; }
        public int ClosedAmount { get; set; }
        public int ReverseClosedAmount { get; set; }
        public double Speed { get; set; }
        public double ReverseSpeed { get; set; }

        public static Results DetermineBestMatch(Results res, List<Results> results)
        {
            double speed = res.Diff;
            double diff = res.Diff - speed;
            bool found = false;

            foreach(Results r in results)
            {
                if(r.Diff - speed < diff)
                {
                    diff = r.Diff - speed;
                    found = true;
                }
                else if(found)
                {
                    return r;
                }
            }
            return null;
        }

        public int CompareTo(object obj)
        {
            Res other = obj as Res;

            if((Profit + ReverseProfit) > (other.Profit + other.ReverseProfit))
            {
                return 1;
            }
            else
            {
                return -1;
            }
        }
    }
}
