﻿/*Copyright 2024 Inconsoft Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using CommonLibrary;

namespace MethodGCalculator
{
    public class SpeedInfo : IComparable
    {
        public double Profit { get; set; }

        public double Hours { get; set; }

        public double Speed { get; set; }

        public int CloseSpeedsCount { get; set; }

        public int CloseHoursCount { get; set; }

        public int CompareTo(object obj)
        {
            SpeedInfo other = obj as SpeedInfo;

            return Profit.CompareTo(other.Profit);
        }
    }


    public class SpeedAverageInfo : IComparable
    {
        public double Profit { get; set; }

        public double Hours { get; set; }

        public double Speed { get; set; }

        public int CompareTo(object obj)
        {
            SpeedAverageInfo other = obj as SpeedAverageInfo;

            return Profit.CompareTo(other.Profit);
        }
    }

    public class RangesSpeeds
    {
        public double MinSpeed { get; set; }

        public double MaxSpeed { get; set; }

        public double PositivePercentage { get; set; }

        public double NegativePercentage { get; set; }
    }

    public class MostCommonSpeedHours : IComparable
    {
        public SpeedInfo Info { get; set; }

        public double CorrelationsSpeeds { get; set; }

        public double CorrelationsHours { get; set; }

        public double Correlations { get; set; }

        public int CompareTo(object obj)
        {
            MostCommonSpeedHours other = obj as MostCommonSpeedHours;

            return Correlations.CompareTo(other.Correlations);
        }

        public void MultiplyCorrelations()
        {
            Correlations = CorrelationsSpeeds * CorrelationsHours;      
        }
    }

    public class Rank : IComparable
    {
        public MostCommonSpeedHours Mcsh { get; set; }

        public double PositionInMostCommon { get; set; }

        public HoursInfo Hours { get; set; }

        public double HoursRank { get; set; }

        public int CompareTo(object obj)
        {
            Rank other = obj as Rank;

            return HoursRank.CompareTo(other.HoursRank);
        }
    }

    public class HoursInfo
    {
        public double Hours { get; set; }

        public int PosOccurence { get; set; }

        public int NegOccurence { get; set; }

        public double PosProfits { get; set; }

        public double NegProfits { get; set; }
    }
}
